#!/bin/sh
case "$1" in
	newca)
		openssl req -new -x509 -config ca.cnf -keyout ca.key \
			-out ca.crt -days 365
		chmod 600 ca.key
		touch ca.txt
		echo "01" > ca.ser
		mkdir -p certs newcerts
	;;
	req)
		openssl req -new -config ca.cnf -keyout ssl.key -out req.pem -days 365
	;;
	cert)
		openssl req -new -x509 -days 365 -nodes \
			-config ca.cnf -out ssl.crt \
			-keyout ssl.key
		openssl x509 -subject -dates -fingerprint -noout \
			-in ssl.key
	;;
	sign)
		openssl ca -config ca.cnf -policy policy_anything -out signed.crt -infiles req.crt
	;;
	*)
		echo "newca  - generate a certificate authority"
		echo "req    - generate a certificate request"
		echo "cert   - generate a self-signed certificate"
		echo "sign   - sign a certificate"
	;;
esac
	
