/*
* Copyright (C) 2002 Alain Stucki <astucki@myisp.ch>
*                    Roman Senn   <roman@dreamlab.ch>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: message.h,v 1.9 2002/05/20 15:24:27 astucki Exp $
*/

/* Message Stuct */
typedef struct {
    const char *name;
    void (*func)(char *source, int ac, char **av);
} Message;

extern Message messages[];
extern Message *find_message(const char *name);

extern void m_nick(char *source, int ac, char **av);
void m_nick(char *source, int ac, char **av);

extern void m_quit(char *source, int ac, char **av);
void m_quit(char *source, int ac, char **av);


/* The User Struct */
struct User
{
        struct 	User*    next;           /* chain of an User structure */
        struct 	User*    prev;           /* chain of an User structure */
        char    nickname[255];
        char    username[255];
        char    nickpass[255];
        char    host[255];
        char    modes[255];
        char    server[255];
        char    fullname[4196];
        int     hopcount;
        int     ident;

};

/* The Nickserv Timer Struct */
struct NickServ_Timer
{
        struct 	NickServ_Timer*  next;
        struct 	NickServ_Timer*  prev;
        time_t  added;
        char    nick[255];
        int warn1;
        int warn2;
        int warn3;
        int warn4;
        int die;
};
