/*
* Copyright (C) 2002 Alain Stucki <astucki@myisp.ch>
*                    Roman Senn   <roman@dreamlab.ch>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: message.c,v 1.8 2002/07/31 21:17:55 astucki Exp $
*/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>
#include <netdb.h>
#include <netinet/in.h>
#include <setjmp.h>
#include <sys/socket.h>
#include <sys/stat.h>	/* for umask() on some systems */
#include <sys/types.h>
#include <sys/time.h>
#include <malloc.h>

#include "services.h"
#include "message.h"



/*==============*/
/* Ping Handler */
/*==============*/
void m_ping(char *source, int ac, char **av)
{
  if (ac < 1)
    return;
  send_cmd(ServerName, "PONG %s %s", ac>1 ? av[1] : ServerName, av[0]);
}

/*=============================*/
/* Handler for Privat Messages */
/*=============================*/
void m_privmsg (char *source, int ac, char **av)
{
  char nick[strlen(source)];
  int i;
  if (ac == 2)
    {
      if (strnicmp(av[0], "NICKSERV", 8) == 0 && nickserv == 1)
        {
          for (i = 0; i <= strlen(source); i++)
            {
              if (source[i] != ' ')
                nick[i] = source[i];
              else
                {
                  nick[i] = '\0';
                  break;
                }
            }
          nickserv_message(nick, av[1]);
        }
    }
  
  return;
  
}



Message messages[] = {
    { "PASS",		NULL },
    { "PONG",  		NULL },
    { "PING",		m_ping	},
    { "NICK",   	m_nick  },
    { "NOTICE",		NULL },
    { "WALLOPS",	NULL },
    { "SVINFO",    	NULL },
    { "GLINE",     	NULL },
    { "CAPAB",     	NULL },
    { "QUIT",      	m_quit },
    { "PRIVMSG",        m_privmsg },
  /*
    { "436",       m_nickcoll },
   { "AWAY",      m_away },
   { "INFO",      m_info },
   { "JOIN",      m_join },
   { "KICK",      m_kick },
   { "KILL",      m_kill },
   { "MODE",      m_mode },
   { "MOTD",      m_motd },
   { "NICK",      m_nick },
   { "PART",      m_part },
   { "SERVER",    m_server },
   { "SQUIT",     m_squit },
   { "STATS",     m_stats },
   { "TIME",      m_time },
   { "TOPIC",     m_topic },
   { "USER",      m_user },
   { "VERSION",   m_version },
   { "WHOIS",     m_whois },
   { "PROTOCTL",  m_protoctl },
   { "SJOIN",     m_sjoin },
   */
    { NULL }
};



Message *find_message(const char *name)
{
  Message *m;
  
  for (m = messages; m->name; m++) 
	{
          if (stricmp(name, m->name) == 0)
            return m;
	}
  return NULL;
}




