/*
* Copyright (C) 2002 Alain Stucki <astucki@myisp.ch>
*                    Roman Senn   <roman@dreamlab.ch>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: mysql.c,v 1.8 2002/07/31 21:17:55 astucki Exp $
*/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>
#include <netdb.h>
#include <netinet/in.h>
#include <setjmp.h>
#include <sys/socket.h>
#include <sys/stat.h>	/* for umask() on some systems */
#include <sys/types.h>
#include <sys/time.h>

#include "services.h"

/* Global Vars */
static MYSQL sql;

/*=======================================*/
/* Etablish a connection to MySQL Server */
/*=======================================*/
int database_connect()
{
  
  mysql_init(&sql);
  if (!mysql_real_connect(&sql, getconfigvalue("MYSQLHOST"), getconfigvalue("MYSQLUSER"), getconfigvalue("MYSQLPASS"), getconfigvalue("MYSQLDB"), atoi(getconfigvalue("MYSQLPORT")),NULL,0))
    {
      seterror("%s", mysql_error(&sql));
      return 0;
    }
  return 1;
}
/*=======================*/
/* Execute a MySQL Query */
/*=======================*/
int query(const char *format, ...)
{
  static char query[8192];
  va_list args;
  int ret;
  
  va_start(args, format);
  
  vsnprintf(query, 8191, format, args);
  
  ret = mysql_query(&sql, query);
  
  va_end(args);
  
  if (ret)
    {
      seterror("%s", mysql_error(&sql));
      error("%s", mysql_error(&sql));
      return 0;
    } else {
      return 1;
    }
}

/*====================*/
/* Store Query result */
/*====================*/
MYSQL_RES *database_result()
{
  MYSQL_RES *res;
  
  res = mysql_store_result(&sql);
  return res;
}
