/*
* Copyright (C) 2002 Alain Stucki <astucki@myisp.ch>
*                    Roman Senn   <roman@dreamlab.ch>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: nickserv.c,v 1.8 2002/07/31 21:17:55 astucki Exp $
*/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>
#include <netdb.h>
#include <netinet/in.h>
#include <setjmp.h>
#include <sys/socket.h>
#include <sys/stat.h>	/* for umask() on some systems */
#include <sys/types.h>
#include <sys/time.h>
#include <malloc.h>

#include "services.h"
#include "message.h"

char *nickserv_checknick(char *nick)
{
        MYSQL_RES *result;
  MYSQL_ROW row;
  char *pass;
  
  
  query("select id, password from nickserv_nicks where nickname = '%s'", nick);
  result = database_result();
  if (mysql_num_rows(result) == 0)
    return NULL;
  else
    {
      row = mysql_fetch_row(result);
      pass = row[1];
      return pass;
    }
}
void nickserv_printhelp(char *nick, char *cmd)
{
  if (cmd == NULL || strlen(cmd) == 0)
    {
      send_cmd(NULL, ":NickServ NOTICE %s :\002*** NickServ Help ****\002", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :REGISTER   -     Register a nickname", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :IDENTIF    -     Identify to your nickname", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :RECOVER    -     Recover your nickname whene someone else is using it", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :DROP       -     Drop registriation of your nick.", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :\002*** End of Help ****\002", nick);
    } else {
      if (strnicmp(cmd, "REGISTER", 8) == 0)
        {
          send_cmd(NULL, ":NickServ NOTICE %s :REGISTER", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Syntax: REGISTER <password>\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Example:\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :/msg NickServ register MyPassword", nick);
        }
      else if (strnicmp(cmd, "IDENTIFY", 8) == 0)
        {
          send_cmd(NULL, ":NickServ NOTICE %s :IDENTIFY", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Syntax: IDENTIFY <password>\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Example:\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :/msg NickServ IDENTIFY MyPassword", nick);
        }
      else if (strnicmp(cmd, "DROP", 4) == 0)
        {
          send_cmd(NULL, ":NickServ NOTICE %s :DROP", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Syntax: DROP <password>\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Example:\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :/msg NickServ DROP MyPassword", nick);
        }
      else if (strnicmp(cmd, "RECOVER", 7) == 0)
        {
          send_cmd(NULL, ":NickServ NOTICE %s :RECOVER", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Syntax: RECOVER <password>\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :\002Example:\002", nick);
          send_cmd(NULL, ":NickServ NOTICE %s :/msg NickServ RECOVER MyPassword", nick);
        }
      else
        {
          send_cmd(NULL, ":NickServ NOTICE %s :Unknown Command: HELP %s", nick, cmd);
        }
      
    }
}
void nickserv_message(char *nick, char *message)
{
  
  char **av;
  int ac;
  MYSQL_RES *result;
  MYSQL_ROW row;
  struct NickServ_Timer *timerptr = NULL;
  
  ac = split_buf(message, &av, 1);
  
  if (ac > 0)
    {
      if (strnicmp(av[0], "HELP", 4) == 0)
        {
          if (av[1] != NULL && strlen(av[1]) > 0 && strcmp(av[0], av[1]) != 0)
            nickserv_printhelp(nick, av[1]);
          else
            nickserv_printhelp(nick, NULL);
          
          
        }
      else if (strnicmp(av[0], "DROP", 4) == 0)
        {
          if (av[1] != NULL && strlen(av[1]) > 0 && strnicmp(av[0], av[1], strlen(av[1])) != 0)
            {
              query("select password from nickserv_nicks where nickname='%s'", nick);
              result = database_result();
              if (mysql_num_rows(result) == 0)
                {
                  send_cmd(NULL, ":NickServ NOTICE %s :The Nickname \002%s\002 is not known in my Database.", nick, nick);
                } 
              else
                {
                  row = mysql_fetch_row(result);
                  if (strcmp(row[0], av[1]) == 0)
                    {
                      /* Password accepted */
                      query("delete from nickserv_nicks where nickname='%s'", nick);
                      send_cmd(NULL, ":NickServ NOTICE %s :Nickname \002%s\002 deleteed.", nick, nick);
                    } 
                  else 
                    {
                      send_cmd(NULL, ":NickServ NOTICE %s :Invalid password", nick);
                    }
                  mysql_free_result(result);
                }
            }
          else
            {
              nickserv_printhelp(nick, "DROP");
            }
          
        }
      else if (strnicmp(av[0], "REGISTER", 8) == 0)
        {
          if (av[1] != NULL && strlen(av[1]) > 0 && strnicmp(av[0], av[1], strlen(av[1])) != 0)
            {
              query("select id from nickserv_nicks where nickname='%s'", nick);
              result = database_result();
              if (mysql_num_rows(result) == 0)
                {
                  query("insert into nickserv_nicks (nickname, registered, password) values ('%s','%ld','%s')", nick, time(NULL), av[1]);
                  send_cmd(NULL, ":NickServ NOTICE %s :The Nickname \002%s\002 has now been registered to you.", nick, nick);
                  send_cmd(NULL, ":NickServ NOTICE %s :Your password is \002%s\002, please remember it and never give it to anyone!", nick, av[1]);
                }
              else
                {
                  send_cmd(NULL, ":NickServ NOTICE %s :The Nickname \002%s\002 is already registered by another user!", nick, nick);
                  
                }
              mysql_free_result(result);
            }
          else
            {
              nickserv_printhelp(nick, "REGISTER");
              return;
            }
        }
      else if (strnicmp(av[0], "IDENTIFY", 8) == 0)
        {
          if (av[1] != NULL && strlen(av[1]) > 0 && strnicmp(av[0], av[1], strlen(av[1])) != 0)
            {
              query("select password from nickserv_nicks where nickname='%s'", nick);
              result = database_result();
              if (mysql_num_rows(result) == 1)
                {
                  row = mysql_fetch_row(result);
                  if (strcmp(row[0], av[1]) == 0)
                    {
                      /* Password accepted */
                      timerptr = gettimerptr(nick);
                      if (timerptr != NULL)
                        {
                          send_cmd(NULL, ":NickServ NOTICE %s :Password accepted", nick);
                          send_cmd(NULL, ":NickServ NOTICE %s :Have a nice day!", nick);
                          destroy_timer(timerptr);
                        }
                      
                      
                    } 
                  else 
                    {
                      send_cmd(NULL, ":NickServ NOTICE %s :Invalid Password", nick);
                    }
                }
              mysql_free_result(result);
              return;
            } 
          else
            {
              nickserv_printhelp(nick, "IDENTIFY");
              return;
            }
        }
      else
        {
          send_cmd(NULL, ":NickServ NOTICE %s :Unknown Command: %s", nick, av[0]);
          send_cmd(NULL, ":NickServ NOTICE %s :for help: /msg NickServ HELP", nick);
        }
    }
  
  
  return;
  
}

void nickserv_changenick(char *nick, char *newnick, time_t timestamp)
{
  char *ret;
  ret = nickserv_checknick(newnick);
  if (ret != NULL)
    {
      send_cmd(NULL, ":NickServ NOTICE %s :This nickname is owned by someone else. Please choose another.", newnick);
      send_cmd(NULL, ":NickServ NOTICE %s :If this is your nickname, please use \002/msg NickServ IDENTIFY <password>\002", newnick);
      send_cmd(NULL, ":NickServ NOTICE %s :You have 60 seconds to comply before you get killed", newnick);
      addkilltimer(newnick);
    }
  
  return;
}

void nickserv_newnick(char *nick)
{
  char *ret;
  ret = nickserv_checknick(nick);
  if (ret != NULL)
    {
      send_cmd(NULL, ":NickServ NOTICE %s :This nickname is owned by someone else. Please choose another.", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :If this is your nickname, please use \002/msg NickServ IDENTIFY <password>\002", nick);
      send_cmd(NULL, ":NickServ NOTICE %s :You have 60 seconds to comply before you get killed", nick);
      addkilltimer(nick);
    }
  
  return;
  
}
