/*
* Copyright (C) 2002 Alain Stucki <astucki@myisp.ch>
*                    Roman Senn   <roman@dreamlab.ch>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: parser.c,v 1.8 2002/08/03 20:04:17 astucki Exp $
*/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>
#include <netdb.h>
#include <netinet/in.h>
#include <setjmp.h>
#include <sys/socket.h>
#include <sys/stat.h>	/* for umask() on some systems */
#include <sys/types.h>
#include <sys/time.h>
#include <malloc.h>

#include "services.h"
#include "message.h"



int split_buf(char *buf, char ***argv_ptr, int colon_special)
{
  static int argvsize = 8;
  static char **argv = NULL;
  int argc;
  char *s;
  
  if (!argv)
    argv = malloc(sizeof(char *) * argvsize);

  argc = 0;
  
  while (*buf) 
    {
      if (argc == argvsize) 
        {
          argvsize += 8;
          argv = realloc(argv, sizeof(char *) * argvsize);
        }
      
      if (*buf == ':' && colon_special) 
        {
          argv[argc++] = buf+1;
          buf = "";
        }
      else
        {
          s = strpbrk(buf, " ");
          if (s) 
            {
              *s++ = 0;
              while (isspace(*s))
                s++;
            }
          else
            s = buf + strlen(buf);
          
          argv[argc++] = buf;
          buf = s;
        }
    }
  *argv_ptr = argv;
  return argc;
}

void process()
{
  char source[64];
  char cmd[64];
  char buf[512];		/* Longest legal IRC command line */
  char *s;
  int ac;			/* Parameters for the command */
  char **av;
  Message *m;
  strscpy(buf, inbuf, sizeof(buf));
  
  if (*buf == ':')
    {
      s = strpbrk(buf, " ");
      if (!s)
        return;
      
      while(isspace(*++s))
        ;
      strscpy(source, buf+1, sizeof(source));
      memmove(buf, s, strlen(s)+1);
    }
  else
    {
      *source = 0;
    }
  
  if (!*buf)
    return;
  s = strpbrk(buf, " ");
  if (s)
    {
      *s = 0;
      while(isspace(*++s))
        ;
    } else
      s = buf + strlen(buf);
  
  strscpy(cmd, buf, sizeof(cmd));
  ac = split_buf(s, &av, 1);
  
  m = find_message(cmd);

  if (m)
    {
      
      if (m->func)
        m->func(source, ac, av);
    } else 
      error("unknown message from server (%s)", inbuf);
  
}
