/*
* Copyright (C) 2002 Alain Stucki <astucki@myisp.ch>
*                    Roman Senn   <blah@blah.ch>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* $Id: ssl.c,v 1.4 2002/08/01 00:22:18 astucki Exp $
*/

#include <stdio.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <openssl/ssl.h>

SSL *ssl_init()
{
  SSL_CTX *ctx;
  SSL_METHOD *meth;
  SSL *ssl;
  
  
  SSL_load_error_strings();
  SSLeay_add_ssl_algorithms();
  meth = SSLv23_client_method();
  ctx = SSL_CTX_new(meth);
  
  if (SSL_CTX_use_certificate_file(ctx, "ircd.pem", SSL_FILETYPE_PEM) <= 0)
    {
      perror("can't open certificate");
      return NULL;
    }
  
  if (SSL_CTX_use_PrivateKey_file(ctx, "ircd.pem", SSL_FILETYPE_PEM) <= 0)
    {
      perror("can't open private key");
      return NULL;
    }
  
  
  if (!SSL_CTX_check_private_key(ctx))
    {
      perror("bad private key");
      return NULL;
    }
  
  ssl = SSL_new(ctx);
  
  if (!ssl)
    {
      perror("can't create ssl object");
      return NULL;
    }
  
  return ssl;
}

  
  
  
